#include cc.def/1

extern char
      line[],              /* input line */
      symtab[];            /* symbol table */

extern int
      eof,                 /* end of file flag */
      input,               /* primary input */
      input2,              /* include input */
      cmode,               /* C text compilation mode */
      ctext,               /* include C text as comments */
      xsp,                 /* Stack pointer */
      lptr;                /* index into input line */

extern char
      *glbptr,             /* into global symbol table */
      *locptr,             /* into local symbol table */
      *cptr;               /* general character pointer */
/*                                      */
/*      Perform a function call         */
/*                                      */
/* called from heir11, this routine will either call */
/*      the named function, or if the supplied ptr is */
/*      zero, will call the contents of HL              */

callfunction(ptr)
     char *ptr;      /* symbol table entry (or 0) */
{
        int nargs;

        nargs=0;
        blanks();       /* already saw open paren */

        if(ptr==0)
             push();       /* calling HL */

        while(streq(line+lptr,")")==0) {
                if(endst())break;

                expression();   /* get an argument */
                if(ptr==0)swapstk(); /* don't push addr */
                push(); /* push argument */
                nargs=nargs+2;  /* count args*2 */
                if (match(",")==0) break;
                }

        needbrack(")");
        if(ptr)call(ptr);
        else callstk();
        xsp=modstk(xsp+nargs);        /* clean up arguments */
} /* callfunction */
junk()
{
        if(an(inbyte()))
                while(an(ch()))gch();
        else while(an(ch())==0) {
                if(ch()==0)break;
                gch();
                }
        blanks();
} /* junk */



endst()
{
        blanks();
        return ((streq(line+lptr,";")|(ch()==0)));
}  /* endst */


illname()
{
      error("illegal symbol name");
      junk();

} /* illname */
multidef(sname)
        char *sname;
{
        error("already defined");
        comment();
        outstr(sname);nl();
} /* multidef */
needbrack(str)
        char *str;
{
        if (match(str)==0) {
             error("missing bracket");
             comment();
             outstr(str);
             nl();
             }
}  /* needbrack */



needlval()
{
        error("must be lvalue");
} /* needlval */
findglb(sname)
        char *sname;
{
        char *ptr;
        ptr=startglb;
        while(ptr!=glbptr) {
                if(astreq(sname,ptr,namemax))
                    return ptr;
                ptr=ptr+symsiz;
                }
        return 0;
}  /* findglb */
findloc(sname)
        char *sname;
{
        char *ptr;
        ptr=startloc;
        while(ptr!=locptr) {
                if(astreq(sname,ptr,namemax))
                    return ptr;
                ptr=ptr+symsiz;
                }
        return 0;
} /* findloc */
addglb(sname,id,typ,value,stg)
        char *sname,id,typ;
        int value;
        char stg;
{
        char *ptr;
        if(cptr=findglb(sname))return cptr;
        if(glbptr>=endglb) {
                error("global symbol table overflow");
                return 0;
                }

        cptr=ptr=glbptr;
        while(an(*ptr++ = *sname++));   /* copy name */

        cptr[ident]=id;
        cptr[type]=typ;
        cptr[storage]=stg;
        cptr[offset]=value;
        cptr[offset+1]=value>>8;
        glbptr=glbptr+symsiz;
        return cptr;
} /* addglb */
addloc(sname,id,typ,value,stg)
        char *sname,id,typ;
        int value;
        char stg;
{
        char *ptr;
        if(cptr=findloc(sname))return cptr;
        if(locptr>=endloc) {
                error("local symbol table overflow");
                return 0;
                }
        cptr=ptr=locptr;
        while(an(*ptr++ = *sname++));   /* copy name */

        cptr[ident]=id;
        cptr[type]=typ;
        cptr[storage]=stg;
        cptr[offset]=value;
        cptr[offset+1]=value>>8;
        locptr=locptr+symsiz;
        return cptr;
} /* addloc */
/* Test if next input string is legal symbol name */
symname(sname)
        char *sname;
{
        int k;char c;
        blanks();
        if(alpha(ch())==0)return 0;
        k=0;
        while(an(ch()))sname[k++]=gch();
        sname[k]=0;
        return 1;
} /* symname */
/* Return next avail internal label number */
getlabel()
{
      extern int nxtlab;
      return(++nxtlab);
}  /* getlabel */



/* Print specified number as label */
printlabel(label)
        int label;
{
        extern char prefix[];
        outstr(prefix);
        outdec(label);
} /* printlabel */
/* Test if given character is alpha */
alpha(c)
        char c;
{
      c=c&127;

      if(c >= 'a' && c <= 'z')
             return 1;
      else if( c >= 'A' && c <= 'Z')
             return 1;
      else if(c == '_')
             return 1;
      else
             return 0;

}  /* alpha */



/* Test if given character is numeric */

numeric(c)
        char c;
{
      c=c&127;
      return((c>='0')&(c<='9'));
}  /* numeric */


/* Test if given character is alphanumeric */
an(c)
      char c;
{
      if(alpha(c))
             return 1;
      else
             return numeric(c);

} /*  an */
/* Print a carriage return and a string only to console */
pl(str)
      char *str;
{
      int k;
       k=0;
      putchar(eol);
      while(str[k])putchar(str[k++]);
} /* pl */
/* while queue management routines */
addwhile(ptr)
      int ptr[];
{
      extern int wq[];
      extern int *wqptr;

      int k;
      if (wqptr==wqmax) {
             error("too many active whiles");
             return;
             }
      k=0;
      while (k<wqsiz)
             *wqptr++ = ptr[k++];

} /* addwhile */


delwhile()
{
      extern int *wqptr;

      if(readwhile())
             wqptr = wqptr - wqsiz;
} /* delwhile */


readwhile()
{
      extern int wq[], *wqptr;

      if (wqptr==wq){
             error("No active whiles");
             return 0;
             }
      else
             return (wqptr-wqsiz);
} /* delwhile */
ch()
{       return(line[lptr]&127);
}  /* ch */


nch()
{       if(ch()==0)return 0;
                else return(line[lptr+1]&127);
} /* nch */


gch()
{       if(ch()==0)return 0;
                else return(line[lptr++]&127);
}  /* gch */


kill()
{       lptr=0;
        line[lptr]=0;
} /* kill */
inbyte()
{
        while(ch()==0)
                {if (eof) return 0;
                inline();
                preprocess();
                }
        return gch();
} /* inbyte */


inchar()
{
        if(ch()==0)inline();
        if(eof)return 0;
        return(gch());
} /* inchar */


inline()
 {
        int k,unit;
        forever {

             if(eof)
                    return;

             if((unit=input2)==0)
                    unit = input;

             kill();
             while((k=getc(unit))>0) {
                    if((k==eol)||(lptr>=linemax))
                           break;
                    if( k == 12) /* form feeds go to blank */
                           k = ' ';
                    line[lptr++]=k;
                    }

             line[lptr]=0;   /* append null */
             if(k<=0) {
                    fclose(unit);
                    if(input2)
                           input2 = 0;
                    else
                           eof = 1;
                    }
             if(lptr) {
                    if((ctext)&(cmode))  {
                           comment();
                           outstr(line);
                           nl();
                           }
                    lptr=0;
                    return;
                    }
             }
} /* inline */
